// { dg-options "-std=gnu++0x" }

// Copyright (C) 2008, 2009 Free Software Foundation
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

#include <memory>
#include <testsuite_hooks.h>

struct A {};

//20.6.11.5 unique_ptr specialized algorithms [unique.ptr.special]

void
test01()
{
  bool test __attribute__((unused)) = true;
 
  std::unique_ptr<A> p1;
  std::unique_ptr<A> p2(new A);
  std::unique_ptr<A> p3;
  
  std::swap(p3, p2);

  VERIFY( p1 != p3 );
  VERIFY( p2 != p3 );
  VERIFY( p1 == p2 );
}

int main()
{
  test01();
  return 0;
}
